package com.example.todo.data;

import android.database.Cursor;
import androidx.annotation.NonNull;
import androidx.lifecycle.ComputableLiveData;
import androidx.lifecycle.LiveData;
import androidx.room.EntityInsertionAdapter;
import androidx.room.InvalidationTracker.Observer;
import androidx.room.RoomDatabase;
import androidx.room.RoomSQLiteQuery;
import androidx.room.SharedSQLiteStatement;
import androidx.sqlite.db.SupportSQLiteStatement;
import com.example.todo.model.Todo;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;

@SuppressWarnings("unchecked")
public final class ToDoDao_Impl implements ToDoDao {
  private final RoomDatabase __db;

  private final EntityInsertionAdapter __insertionAdapterOfTodo;

  private final SharedSQLiteStatement __preparedStmtOfDeleteAll;

  private final SharedSQLiteStatement __preparedStmtOfDeleteAToDo;

  private final SharedSQLiteStatement __preparedStmtOfUpdatetoDoItem;

  public ToDoDao_Impl(RoomDatabase __db) {
    this.__db = __db;
    this.__insertionAdapterOfTodo = new EntityInsertionAdapter<Todo>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR ABORT INTO `todo_table`(`id`,`todo_col`) VALUES (nullif(?, 0),?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, Todo value) {
        stmt.bindLong(1, value.getId());
        if (value.getToDo() == null) {
          stmt.bindNull(2);
        } else {
          stmt.bindString(2, value.getToDo());
        }
      }
    };
    this.__preparedStmtOfDeleteAll = new SharedSQLiteStatement(__db) {
      @Override
      public String createQuery() {
        final String _query = "DELETE FROM todo_table";
        return _query;
      }
    };
    this.__preparedStmtOfDeleteAToDo = new SharedSQLiteStatement(__db) {
      @Override
      public String createQuery() {
        final String _query = "DELETE FROM TODO_TABLE WHERE id = ?";
        return _query;
      }
    };
    this.__preparedStmtOfUpdatetoDoItem = new SharedSQLiteStatement(__db) {
      @Override
      public String createQuery() {
        final String _query = "UPDATE TODO_TABLE SET `todo_col` = ? WHERE id = ?";
        return _query;
      }
    };
  }

  @Override
  public void insert(Todo toDo) {
    __db.beginTransaction();
    try {
      __insertionAdapterOfTodo.insert(toDo);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public void deleteAll() {
    final SupportSQLiteStatement _stmt = __preparedStmtOfDeleteAll.acquire();
    __db.beginTransaction();
    try {
      _stmt.executeUpdateDelete();
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
      __preparedStmtOfDeleteAll.release(_stmt);
    }
  }

  @Override
  public int deleteAToDo(int id) {
    final SupportSQLiteStatement _stmt = __preparedStmtOfDeleteAToDo.acquire();
    __db.beginTransaction();
    try {
      int _argIndex = 1;
      _stmt.bindLong(_argIndex, id);
      final int _result = _stmt.executeUpdateDelete();
      __db.setTransactionSuccessful();
      return _result;
    } finally {
      __db.endTransaction();
      __preparedStmtOfDeleteAToDo.release(_stmt);
    }
  }

  @Override
  public int updatetoDoItem(int id, String todoText) {
    final SupportSQLiteStatement _stmt = __preparedStmtOfUpdatetoDoItem.acquire();
    __db.beginTransaction();
    try {
      int _argIndex = 1;
      if (todoText == null) {
        _stmt.bindNull(_argIndex);
      } else {
        _stmt.bindString(_argIndex, todoText);
      }
      _argIndex = 2;
      _stmt.bindLong(_argIndex, id);
      final int _result = _stmt.executeUpdateDelete();
      __db.setTransactionSuccessful();
      return _result;
    } finally {
      __db.endTransaction();
      __preparedStmtOfUpdatetoDoItem.release(_stmt);
    }
  }

  @Override
  public LiveData<List<Todo>> getAllToDos() {
    final String _sql = "SELECT * FROM todo_table ORDER BY `todo_col` DESC";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return new ComputableLiveData<List<Todo>>(__db.getQueryExecutor()) {
      private Observer _observer;

      @Override
      protected List<Todo> compute() {
        if (_observer == null) {
          _observer = new Observer("todo_table") {
            @Override
            public void onInvalidated(@NonNull Set<String> tables) {
              invalidate();
            }
          };
          __db.getInvalidationTracker().addWeakObserver(_observer);
        }
        final Cursor _cursor = __db.query(_statement);
        try {
          final int _cursorIndexOfId = _cursor.getColumnIndexOrThrow("id");
          final int _cursorIndexOfToDo = _cursor.getColumnIndexOrThrow("todo_col");
          final List<Todo> _result = new ArrayList<Todo>(_cursor.getCount());
          while(_cursor.moveToNext()) {
            final Todo _item;
            final String _tmpToDo;
            _tmpToDo = _cursor.getString(_cursorIndexOfToDo);
            _item = new Todo(_tmpToDo);
            final int _tmpId;
            _tmpId = _cursor.getInt(_cursorIndexOfId);
            _item.setId(_tmpId);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    }.getLiveData();
  }
}
